



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【树形DP】BZOJ1040-[ZJOI2008]骑士</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【树形DP】BZOJ1040-[ZJOI2008]骑士</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-26 19:06:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>【题目大意】</p>
<p>有n个骑士，给出他们的能力值和最痛恨的一位骑士。选出一个骑士军团，使得军团内没有矛盾的两人（不存在一个骑士与他最痛恨的人一同被选入骑士军团的情况），并且，使得这支骑士军团最具有战斗力，求战斗力的最大值。</p>
<p>【思路】</p>
<p>首先yy一下,可以知道这是一个基环森林。我们可以用以下方法：</p>
<p>首先在每一棵基环树的环上任意找到一条边（用dfs来实现），记它的两个端点为u和v。然后删掉这条边（我这里用的方法是记录u,v在对方容器中的位置，并在后续操作中忽略这条边）。由于u和v不能同时取，在删掉u和v之间的边后存在以下两种情况：</p>
<p>令g[i]为不取i时i及其子树的最大战斗力总和，f[i]则表示取i。</p>
<p>(1)u不取，v任意。则以u为根进行树形DP，结果为g[u]；</p>
<p>(2)v不取，u任意。则以v为根进行树形DP，结果为g[v]。</p>
<p>然后ans+max(g[u],g[v])。</p>
<p>树形DP的过程非常地常规，就不赘述了 。</p>
<div>
<pre class="prettyprint linenums"> #include&lt;iostream&gt;<br />
 #include&lt;cstdio&gt;<br />
 #include&lt;cstring&gt;<br />
 #include&lt;algorithm&gt;<br />
 #include&lt;vector&gt;<br />
 using namespace std;<br />
 const int MAXN=+;<br />
 typedef long long ll;<br />
 vector&lt;int&gt; E[MAXN];<br />
 int n,power[MAXN],hate[MAXN];<br />
 int vis[MAXN];<br />
 int U,V;<br />
 ll g[MAXN],f[MAXN];

 void addedge(int u,int v)<br />
 {<br />
     E[u].push_back(v);<br />
     E[v].push_back(u);<br />
 }

 void dfs(int u,int fr)<br />
 {<br />
     vis[u]=;<br />
     for (int i=;i&lt;E[u].size();i++)<br />
     {<br />
         int to=E[u][i];<br />
         if (to!=fr)<br />
         {<br />
             if (!vis[to]) dfs(to,u);<br />
             else<br />
             {<br />
                 vis[to]=;<br />
                 U=u;V=to;<br />
                 return;<br />
             }<br />
         }<br />
     }<br />
 }

 void TreeDP(int u,int fr,int rt,int ban)<br />
 {<br />
     vis[u]=;<br />
     f[u]=power[u];<br />
     g[u]=;<br />
     for (int i=;i&lt;E[u].size();i++)<br />
     {<br />
         int to=E[u][i];<br />
         if (u==rt &amp;&amp; i==ban) continue;<br />
         if (to!=fr &amp;&amp; to!=rt)<br />
         {<br />
             TreeDP(to,u,rt,ban);<br />
             f[u]+=g[to];<br />
             g[u]+=max(g[to],f[to]);<br />
         }<br />
     }<br />
 }

 void init()<br />
 {<br />
     scanf("%d",&amp;n);<br />
     for (int i=;i&lt;=n;i++)<br />
     {<br />
         scanf("%d%d",&amp;power[i],&amp;hate[i]);<br />
         addedge(i,hate[i]);<br />
     }<br />
 } 

 void get_ans()<br />
 {<br />
     memset(vis,,sizeof(vis));<br />
     ll ans=;<br />
     for (int i=;i&lt;=n;i++)<br />
         if (!vis[i])<br />
         {<br />
             dfs(i,-);<br />
             int banu,banv;<br />
             for (int i=;i&lt;E[U].size();i++) if (E[U][i]==V)<br />
             {<br />
                 banu=i;<br />
                 break;<br />
             }<br />
             for (int i=;i&lt;E[V].size();i++) if (E[V][i]==U)<br />
             {<br />
                 banv=i;<br />
                 break;<br />
             }

             TreeDP(U,-,U,banu);<br />
             ll uans=g[U];

             TreeDP(V,-,V,banv);<br />
             ll vans=g[V];<br />
             ans+=max(uans,vans);<br />
         }<br />
     cout&lt;&lt;ans&lt;&lt;endl;<br />
 }

 int main()<br />
 {<br />
     init();<br />
     get_ans();<br />
     return ;<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xrql119o.html">Android请求网络共通类&mdash;&mdash;Hi&lowbar;博客 Android App 开发笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql5r2e8.html">Delphi&colon; 有关Form处理 &colon;需要调用的时候进行调用。</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kk3238.html">JS操作页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mx5yo9.html">030医疗项目-模块三：药品供应商目录模块&mdash;&mdash;供货商药品目录查询功能----------Dao层：基本的查询语句的编写</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gkm048.html">spring mvc处理静态资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kzzrr8.html">zabbix centos 6&period;4 安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok56y59.html">Codevs 1063 合并果子</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ykmx0q.html">UVA 12382 Grid of Lamps 贪心</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ow12j9.html">ubuntu用户及用户组文件信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1e4679.html">改变eclipse工程中代码的层次结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmond49.html">在IIS Express中调试时无法读取配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn3r70q.html">本人对于JavaScript的一些总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yoy6r8.html">【已解决】谁动了我的CurrentPrincipal？求助我在给Artech的wcf petshop增加授权机制的时候遇到的问题。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1vnjgq.html">win7搭建php7&plus;apache2&period;4</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpowojq.html">更新几篇之前写在公众号上的文章：线性可分时SVM理论推导；关联分析做捆绑销售和推荐；分词、去停用词和画词云</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey3lrx9.html">Netty4 学习笔记之一&colon;客户端与服务端通信 demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkxvv08.html">Jmeter&lowbar;脚本参数化与内存溢出的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pvd538.html">js中ASCII码和字符互相转换的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdn36d9.html">黄聪：Windows2012-IIS8安装SSL证书</a>
		</li>
						<li><a href="https://www.batexi.com/a/96010549.html">spring 的 ApplicationContext&period;getBean&lpar;type&rpar;  无法获取bean&comma;报错</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mj3kxr8.html">array&lowbar;unique&lpar;&rpar; 去重复</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj3k3o8.html">【洛谷 P4437】 &lbrack;HNOI&sol;AHOI2018&rsqb;排列（贪心，堆）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjnkm0q.html">【洛谷 P4291】 &lbrack;HAOI2008&rsqb;排名系统（Splay，Trie）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emnx0z9.html">DNSLOG在渗透测试中的玩法儿</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn7lkkq.html">ubuntu之安装pycharm编辑器</a>
			</li>
						<li><a href="https://www.batexi.com/a/8koy4orq.html">配置kernel的log buf大小（如果kmsg log被覆盖）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v0ny5q.html">selenium grid应用2-多节点执行用例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkdpp18.html">用js实现登录的简单验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkdny38.html">HTML  禁止显示input默认提示信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/9534k4z8.html">CSU 1425 Prime Summation</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
